/*
---------------------------------------------------------------------
 This file is part of CPB (Correlated Pattern Biclustering Algorithm)
 Copyright (c) 2011, 
 By:    Doruk Bozdag, 
        Umit V. Catalyurek,
        Mehmet Deveci,
        Onur Kucuktunc,
        Kemal Eren
---------------------------------------------------------------------
 For license info, please see the README.txt and LICENSE.txt files in the main directory.
---------------------------------------------------------------------
*/

#define LEFT(x)  (2*(x+1)-1)   /* left child of a node */
#define RIGHT(x) (2*(x+1)) /* right child of a node */
#define PARENT(x) ((x-1)/2)  /* parent of a node */
#define SWAP(x,y) { node t=(x); (x) = (y); (y)=(t); }

typedef struct node {
    int id;
    double key;
} node;

typedef struct heap {
    int size;
    int maxsize;
    node *nodes;
} heap; 


/**********************************************************************************************/
/* Prototypes */ 
void Heap_Create(heap *a, int maxsize);
void Heap_Insert(heap *a, int id, double key, int *hmap);
void Heapify(heap *a, int i, int *hmap);
void Heap_Delete(heap *a, int i, int *hmap); 
int  Heap_Extract_Max(heap *a, node *node0, int *hmap);
int  Heap_Max(heap *a, node *node0);
void Heap_Change_Key(heap *a, int i, double newkey, int *hmap);
void Heap_Destroy(heap *a);
